#include "keyboard.hpp"
#include "keyboard_syscalls.h"
#include "display.h"
#include "color.h"

int e = 0;
int d = 0;
int birdx = 171;
int birdy = 30;
int gravity = 1;
int birdxv = 0;
int birdyv = 0;
int l = 1;
int h = 0;
int w = 0;
int objectx = 340;
int objecty = 216;
int birdmass = 3;
int objectmass = 4;
int objectxv = 0;
int objectyv = 0;


int PRGM_GetKey(){
  unsigned char buffer[12];
  PRGM_GetKey_OS( buffer );
  return ( buffer[1] & 0x0F ) * 10 + ( ( buffer[2] & 0xF0 ) >> 4 );
}

void CopySprite(const void* datar, int x, int y, int width, int height) { 
   color_t*data = (color_t*) datar; 
   color_t* VRAM = (color_t*)0xA8000000; 
   VRAM += LCD_WIDTH_PX*y + x; 
   for(int j=y; j<y+height; j++) { 
      for(int i=x; i<x+width; i++) { 
         *(VRAM++) = *(data++); 
     } 
     VRAM += LCD_WIDTH_PX-width; 
   } 
} 

void plot(int x0, int y0, int color) { 
   char* VRAM = (char*)0xA8000000; 
   VRAM += 2*(y0*LCD_WIDTH_PX + x0); 
   *(VRAM++) = (color&0x0000FF00)>>8; 
   *(VRAM++) = (color&0x000000FF); 
   return; 
}

void drawLine(int x1, int y1, int x2, int y2, int color) { 
    signed char ix; 
    signed char iy; 
  
    // if x1 == x2 or y1 == y2, then it does not matter what we set here 
    int delta_x = (x2 > x1?(ix = 1, x2 - x1):(ix = -1, x1 - x2)) << 1; 
    int delta_y = (y2 > y1?(iy = 1, y2 - y1):(iy = -1, y1 - y2)) << 1; 
  
   plot(x1, y1, color);  
    if (delta_x >= delta_y) { 
        int error = delta_y - (delta_x >> 1);        // error may go below zero 
        while (x1 != x2) { 
            if (error >= 0) { 
                if (error || (ix > 0)) { 
                    y1 += iy; 
                    error -= delta_x; 
                }                           // else do nothing 
         }                              // else do nothing 
            x1 += ix; 
            error += delta_y; 
            plot(x1, y1, color); 
        } 
    } else { 
        int error = delta_x - (delta_y >> 1);      // error may go below zero 
        while (y1 != y2) { 
            if (error >= 0) { 
                if (error || (iy > 0)) { 
                    x1 += ix; 
                    error -= delta_y; 
                }                           // else do nothing 
            }                              // else do nothing 
            y1 += iy; 
            error += delta_x;  
            plot(x1, y1, color); 
        } 
    } 
} 

void CopySpriteMasked(const void*datar, int x, int y, int width, int height, int maskcolor) { 
   color_t*data = (color_t*) datar; 
   color_t* VRAM = (color_t*)0xA8000000; 
   VRAM += LCD_WIDTH_PX*y + x; 
   for(int j=y; j<y+height; j++) { 
      for(int i=x; i<x+width;  i++) { 
         if (*(data) != maskcolor) { 
            *(VRAM++) = *(data++); 
         } else { VRAM++; data++; } 
      } 
      VRAM += LCD_WIDTH_PX-width; 
   } 
}

const color_t angrybird1[800] = {
		0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,
		0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0x7800,0xd004,0x9005,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,
		0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xa2cd,0x92ac,0x4801,0xe005,0xe805,0xa804,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,
		0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0x5000,0xf805,0xe805,0xe005,0x6802,0x8803,0xe806,0x8804,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,
		0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0x0081,0x8003,0xb004,0xe005,0xe005,0xc004,0xf808,0x49e8,0xf800,0xf800,0xf800,0xf800,0xf800,
		0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0x3904,0xc804,0xe005,0xd005,0xd005,0xd005,0xd005,0xd005,0xf808,0x7803,0xf800,0xf800,0xf800,0xf800,
		0xf800,0xf800,0xf800,0xf800,0xf800,0x4124,0xd802,0xd805,0xd005,0xd005,0xd005,0xd005,0xd005,0xd005,0xd004,0xf007,0xa804,0xf800,0xf800,0xf800,
		0xf800,0xf800,0xf800,0xf800,0x740f,0xa800,0xd005,0xd005,0xd005,0xd005,0xd805,0xe005,0xd005,0xd005,0xd005,0xd005,0xe806,0x8003,0xf800,0xf800,
		0xf800,0xf800,0xf800,0xf800,0x5000,0xc802,0xd805,0xd005,0xd005,0xd805,0xc005,0x6002,0xf006,0xd005,0xd005,0xd005,0xd805,0xe805,0x6a6a,0xf800,
		0xf800,0xf800,0x0000,0x532c,0xd001,0xc003,0xd005,0xd005,0xd005,0xe005,0x3001,0x0000,0x3000,0xe805,0xe005,0xf006,0xa003,0x0000,0x5001,0xf800,
		0xf800,0x0000,0x31e7,0x4800,0xc802,0xc003,0xd005,0xd005,0xd805,0xd005,0xe004,0x5a29,0x1103,0x0000,0x7001,0x2000,0x0020,0x2000,0xa802,0xf800,
		0xf800,0xf800,0x08c3,0x8001,0xc002,0xc003,0xd005,0xd805,0xb804,0xd805,0xa001,0xefff,0xceba,0x94d3,0x4aec,0x5b2d,0xffff,0x830c,0xe003,0xf800,
		0xf800,0xf800,0xf800,0x8800,0xc002,0xc003,0xd005,0xd805,0x9003,0xc805,0x9802,0x73ae,0xa3f1,0x8c52,0xa446,0x6b89,0x5800,0x8002,0xc003,0xf800,
		0xf800,0xf800,0xf800,0x7800,0xc002,0xc002,0x9004,0xd005,0x9803,0xc004,0xa003,0xa002,0x7841,0xe581,0xfe23,0xfe63,0x8ba2,0x8003,0xc002,0xf800,
		0xf800,0xf800,0xf800,0x58a3,0xc802,0xc002,0xa802,0xd004,0xc804,0xd9c9,0xdbad,0x8a09,0xa4c2,0xeda3,0xfdc3,0xfe23,0xfec4,0x8ba2,0xa001,0xf800,
		0xf800,0xf800,0xf800,0xf800,0xb000,0xc002,0xb800,0xcb0b,0xeeb6,0xdeb6,0xcdd3,0x8bec,0x8453,0x7ac4,0xb382,0xaba2,0x8321,0xfe82,0x0001,0xf800,
		0xf800,0xf800,0xf800,0xf800,0x2924,0xa000,0xddd3,0xcdf3,0xcd72,0xcd51,0xcd72,0xddd3,0x93ec,0xb382,0xf481,0x93e6,0xe088,0x4000,0xf800,0xf800,
		0xf800,0xf800,0xf800,0xf800,0xf800,0x4acb,0x41c5,0xd592,0xddf3,0xd5b3,0xd5b2,0xd592,0xddd3,0xcd93,0x93cd,0xd5d4,0x20a1,0xf800,0xf800,0xf800,
		0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0x39e8,0x39a6,0x5206,0x7309,0x836b,0x7b09,0x5226,0x41c6,0xf800,0xf800,0xf800,0xf800,0xf800,
		0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800,0xf800
	};

const color_t Object1[1320] = {
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,
		0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4,0xfbe4
	};

int main() {
  while(1) {
    int key = PRGM_GetKey();
    if(key == KEY_PRGM_MENU) {  GetKey(&key); }
    drawLine(30, 186, (-e)+32, (-d)+186, 0x0000);
    drawLine(35, 186, (-e)+33, (-d)+186, 0x0000);
    h = h + w;
    if (d < -18){
        d = -18;
    }
    if (e > 18){
        e = 18;
    }
    if (birdy < 364 || birdy > 0){
        CopySpriteMasked(angrybird1, birdy-e, birdx-d, 20, 20, COLOR_RED);
    }
    CopySprite(Object1, objecty, objectx, 15, 44);
    birdxv = gravity + birdxv;
    if (birdx >= 171){
        birdx = 171;
        birdxv = 0;
    }
    if (birdx < 171){
        birdx = birdx + birdxv;
        birdy = birdy + birdyv;
    }

    if (key==KEY_PRGM_SHIFT && h==0){
        birdxv = d;
        birdyv = e;
        birdx = birdx + birdxv;
        birdy = birdy + birdyv;
        d = 0;
        e = 0;
        w = 1;
    }
    objectx = objectx + objectxv;
    objecty = objecty + objectyv;
    if (key==KEY_PRGM_LEFT){
        e = e + 1;
    }
    if (key==KEY_PRGM_UP){
        d = d + 1;
    }
    if (key==KEY_PRGM_RIGHT){
        e = e - 1;
    }
    if (key==KEY_PRGM_DOWN){
        d = d - 1;
    }
    if (h==5){
        w = 0;
        h = 0;
    }
    if ((birdx+10 && birdy+10)>=objectx && (birdx+10 && birdy+10)<=objectx+44){
    birdxv = (1*objectmass*(birdyv-birdxv)+birdmass*birdxv+objectmass*birdxv)/(birdmass+objectmass);
    birdyv = (1*objectmass*(birdxv-birdyv)+birdmass*birdyv+objectmass*birdyv)/(birdmass+objectmass);
    objectxv = (1*birdmass*(objectyv-objectxv)+objectmass*objectxv+birdmass*objectxv)/(birdmass+objectmass);
    objectyv = (1*birdmass*(objectxv-objectyv)+objectmass*objectyv+birdmass*objectyv)/(birdmass+objectmass);
    }
    Bdisp_PutDisp_DD();
    Bdisp_AllCr_VRAM();
  }
  return 0;
}
